#!/bin/bash

CAT=$2

if [ -z "$CAT" ]; then
    BENCHMARKS=$(cat benchmarks/list.txt)
else
    BENCHMARKS=$(cat benchmarks/list-$CAT.txt)
fi

TOOL=$1
LOG=logs
DATA=data

mkdir -p $LOG
mkdir -p $DATA

for b in $BENCHMARKS; do
    DIR=$TOOL/$(dirname $b | sed 's:[^/]*/::')
    FILE=$(basename $b)
    STDERR=$LOG/$DIR/$FILE.stderr
    STDOUT=$LOG/$DIR/$FILE.stdout
    RES=$DATA/$DIR/$FILE
    mkdir -p $LOG/$DIR
    mkdir -p $DATA/$DIR
    if [ ! -f $STDERR ] || [ ! -f $STDOUT ]; then
        ./scripts/run_$TOOL.sh $b 2> .tmp.stderr > .tmp.stdout
        mv .tmp.stderr $STDERR
        mv .tmp.stdout $STDOUT
    fi
    cat $STDOUT $STDERR | python ./scripts/filters/$TOOL.py > $RES
done
